<?php
/**
 * @package    JMyLife
 * @subpackage Components
 * @version    1.0.16
 * @copyright  2009-2010 Jeff Channell
 * components/com_jmylife/controllers/item.php
 * @license

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 */
// No direct access
defined('_JEXEC') or die('Restricted access');
// imports
jimport('joomla.application.component.controller');
JLoader::import('components.com_jmylife.helpers.itemid', JPATH_ADMINISTRATOR, '');
JLoader::import('components.com_jmylife.helpers.story', JPATH_ADMINISTRATOR, '');
/**
 * JMyLife Item Controller
 *
 * @package    JMyLife
 * @subpackage Components
 */
class JmylifeControllerItem extends JController
{
	/**
	 * Method to display the view
	 *
	 * @access    public
	 */
	function display() {
		$layout = JRequest::getWord('layout', 'default');
		if ('edit' == $layout) {
			$app = JFactory::getApplication();
			$id = JRequest::getInt('id');
			$idhelper = JmylifeItemidHelper::getInstance();
			$itemid = $idhelper->story($id);
			$storylink = JRoute::_("index.php?option=com_jmylife&view=item&id={$id}&Itemid={$itemid}", false);
			$story = JmylifeStoryHelper::getInstance();
			if (!$story->editAllowed()) {
				$app->redirect($storylink, JText::_('COM_JMYLIFE_ERROR_STORY_EDITNOTAUTH'));
				exit();
			}
		}
		parent::display();
	}
	/**
	 * Method to save an edited item
	 */
	function save() {
		$user = JFactory::getUser();
		$app = JFactory::getApplication();
		$cfg = JmylifeConfiguration::getInstance();
		$id = JRequest::getInt('id');
		$idhelper = JmylifeItemidHelper::getInstance();
		$itemid = $idhelper->story($id);
		$storylink = JRoute::_("index.php?option=com_jmylife&view=item&id={$id}&Itemid={$itemid}", false);
		$editlink = JRoute::_("index.php?option=com_jmylife&view=item&id={$id}&layout=edit&Itemid={$itemid}", false);
		// check token
		if (!JRequest::checkToken()) {
			$app->redirect($storylink, JText::_('COM_JMYLIFE_ERROR_INVALID_TOKEN'));
			exit();
		}
		$story = JmylifeStoryHelper::getInstance();
		// check if editing is allowed
		if (!$story->editAllowed()) {
			$app->redirect($storylink, JText::_('COM_JMYLIFE_ERROR_STORY_EDITNOTAUTH'));
			exit();
		}
		// start building update
		$update = array(
			'fulltext' => trim(JRequest::getString('fulltext')),
			'title' => JRequest::getString('title', ''),
			'user_email' => JRequest::getVar('user_email')
		);
		if ($cfg->getBool('edit_category')) {
			$update['catid'] = JRequest::getInt('catid');
		}
		// check if options are present and if so, are they supposed to be?
		if ($cfg->getBool('edit_options')) {
			// make sure user has proper gid
			if (in_array($user->gid, array($cfg->getInt('frontend_user_group'), 25))) {
				$update['published'] = JRequest::getInt('published');
				$update['allow_comments'] = JRequest::getInt('allow_comments');
				$update['allow_votes'] = JRequest::getInt('allow_votes');
			}
		}
		JLoader::import('components.com_jmylife.helpers.string', JPATH_ADMINISTRATOR, '');
		$string = JmylifeStringHelper::getInstance();
		// truncate fulltext if necessary
		if ($limit = $cfg->getInt('editor_length', 0)) {
			$update['fulltext'] = $string->shorten($update['fulltext'], $limit, false);
		}
		// update query template
		$query = "UPDATE #__jmylife_stories SET %s WHERE id=%s";
		// fetch dbo
		JLoader::import('components.com_jmylife.helpers.database', JPATH_ADMINISTRATOR, '');
		$db = JmylifeDatabaseHelper::getInstance();
		// build query
		$parts = array();
		foreach ($update as $key => $val) {
			$parts[] = $db->nameQuote($key).' = '.$db->Quote($val);
		}
		if (!count($parts)) {
			$app->redirect($editlink, JText::_('COM_JMYLIFE_ERROR_STORY_CANNOTSAVE'));
			exit();
		}
		$query = sprintf($query, implode(',', $parts), $id);
		// if query is successful go to story, else go back to edit
		if ($db->exec($query)) {
			if ($update['published']) {
				$app->redirect($storylink, JText::_('COM_JMYLIFE_STORY_SAVED'));
			} else {
				$app->redirect(JRoute::_('index.php?option=com_jmylife&Itemid='.$idhelper->view('list'), false), JText::_('COM_JMYLIFE_STORY_SAVED'));
			}
		} else {
			$app->redirect($editlink, JText::_('COM_JMYLIFE_ERROR_STORY_CANNOTSAVE'));
		}
	}
}