<?php
/**
 * @package    JMyLife
 * @subpackage Components
 * @version    1.0.16
 * @copyright  2009-2010 Jeff Channell
 * components/com_jmylife/views/submit/view.html.php
 * @license

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 */
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
// imports
jimport( 'joomla.application.component.view' );

/**
 * HTML View Submit class for the JMyLife Component
 *
 * @package    JMyLife
 */

class JmylifeViewSubmit extends JView
{
	function display( $tpl = null )
	{
		$_JMLConfig = JmylifeConfiguration::getInstance();
		// J!1.6 doesn't use mainframe
		$appl =& JFactory::getApplication();
		// user check
		$user =& JFactory::getUser();
		if( $user->guest && $_JMLConfig->getInt('user_stories_only') == 1 )
		{
			JLoader::import('components.com_jmylife.helpers.itemid', JPATH_ADMINISTRATOR, '');
			$itemid = JmylifeItemidHelper::getInstance();
			$appl->enqueuemessage( JText::_( 'COM_JMYLIFE_ERROR_STORY_NOGUEST' ) );
			$appl->redirect('index.php?option=com_jmylife&view=list&Itemid='.$itemid->category(0));
		}

		$assetPath = JURI::root().'components/com_jmylife/assets/';
		$libPath = JURI::root().'components/com_jmylife/libraries/';

		//$params	=& $appl->getParams( 'com_jmylife' );
		$document =& JFactory::getDocument();
		// BUG: no leading / - fixed in 1.0.4
		$document->addScript( $assetPath.'js/submissionToggle.js' );

		// try to disable textarea resizing, if enabled
		if( $_JMLConfig->getInt('disable_resize',0) == 1 )
		{
			$document->addStyleDeclaration( 'textarea{resize:none;}' );
		}

		// text limit
		if ($limit = $_JMLConfig->getInt('editor_limit',0)) {
			$document->addScript($assetPath.'js/limitText.js');
			$document->addScriptDeclaration('(function($){
	$(document).ready(function() {
		$("#comJMyLifeFulltext").limitText({
			limit: '.$limit.',
			text: {
				charleft: "'.JText::_('COM_JMYLIFE_SUBMIT_EDITOR_LENGTH_CHARLEFT').'",
				nomore: "'.JText::_('COM_JMYLIFE_SUBMIT_EDITOR_LENGTH_NOMORE').'"
			}
		}).trigger("change");
	});
})(window.jml.jQuery);');
		}

		$editorwidth = $_JMLConfig->getInt( 'editor_width', 300 );
		$editorheight = $_JMLConfig->getInt( 'editor_height', 180 );
		// add extras to document
			$document->addScriptDeclaration('window.jmlWYSIWYG=0;');
			$document->addStyleDeclaration( '#comJMyLifeStorySubmitText textarea{width:'.$editorwidth.'px !important;height:'.$editorheight.'px !important;}' );

		JLoader::import('components.com_jmylife.helpers.html', JPATH_ADMINISTRATOR, '');
		$html = JmylifeHtmlHelper::getInstance();
		$this->assignRef('html', $html);
		
		// Get Categories
		$categories =& $this->get( 'Categories' );
		// since 1.0.5 preprocess data before sending to template
		if( count( $categories ) )
		{
			foreach( $categories as $key => $item )
			{
				$categories[$key]->name = $html->clean( $item->name );
			}
		}

		// push data into the template
		$this->assignRef( 'categories', $categories );
		
		// since 1.0.5
		// pass-by-reference removed in 1.0.6
		$this->assignRef( 'cparams', $_JMLConfig );

		// not used in 1.0.4 due to IE bug - validation done server-side & returned to custom ajax...
		// add validation
		//JHTML::_('behavior.formvalidation');
		// default templates don't use this? lame...
		//$document->addStyleDeclaration('input.invalid,textarea.invalid{border:1px solid red;}');

		parent::display( $tpl );
	}
}